# AttachDisks

## 1. API Description

This API (AttachDisks) is used to attach disks to instance.

{% hint style="info" %} <mark style="color:blue;">**Note**</mark>

* <mark style="color:blue;">A maximum of 10 disks can be attached to an instance in one request.</mark>
* <mark style="color:blue;">Quantity of attached disks cannot exceed available disk numbers of an instance, that is usually 15 disks.</mark>
* <mark style="color:blue;">The disk and the instance to which you want to attach the disk reside in the same zone.</mark>
* <mark style="color:blue;">You can only attach disks to the available instance. Please note that status of</mark> <mark style="color:blue;">`DEPLOYING`</mark> <mark style="color:blue;">or</mark> <mark style="color:blue;">`PENDING`</mark> <mark style="color:blue;">is not available.</mark>
* <mark style="color:blue;">Disks must be detachable (</mark><mark style="color:blue;">`portable`</mark> <mark style="color:blue;">=</mark> <mark style="color:blue;">`true`</mark><mark style="color:blue;">) .</mark>
* <mark style="color:blue;">This API is an async API. A request ID is returned after the creation request is sent. However, it does not mean the operation has been completed. You can use</mark> [<mark style="color:purple;">`DescribeDisks`</mark>](/api-reference/compute/vm/disk/describedisks.md) <mark style="color:blue;">to query the status of the disk. If the status changes from</mark> <mark style="color:blue;">`AVAILABLE`</mark> <mark style="color:blue;">to</mark> <mark style="color:blue;">`IN_USE`</mark><mark style="color:blue;">, it means that the disk is attached successfully.</mark>
  {% endhint %}

## 2. Input Parameters

The following request parameter list only provides API request parameters.

| Parameter Name | Required | Type            | Description                                       |
| -------------- | -------- | --------------- | ------------------------------------------------- |
| diskIds        | Yes      | Array of String | ID list of disks.                                 |
| instanceId     | Yes      | String          | ID of instance to which the disks to be attached. |

## 3. Output Parameters

| Parameter Name | Type   | Description                                                                                                           |
| -------------- | ------ | --------------------------------------------------------------------------------------------------------------------- |
| requestId      | String | <p>The unique request ID, which is returned for each request.</p><p>RequestId is required for locating a problem.</p> |

## 4. Code Example

{% tabs %}
{% tab title="Example" %}
**Attach disks to an instance.**

```json
POST /api/v2/vm HTTP/1.1
Host: console.zenlayer.com
Content-Type: application/json
X-ZC-Action: AttachDisks
<Common Request Params>

Request:
{
  "diskIds": [
    "your-disk-id"
  ],
  "instanceId": "your-instance-id"
}

Response:
{
  "requestId": "T425ED37F-1BE5-4274-B068-9A58C51F21A8",
  "response": {
    "requestId": "T425ED37F-1BE5-4274-B068-9A58C51F21A8"
  }
}
```

{% endtab %}
{% endtabs %}

## 5. Developer Resources

Zenlayer Cloud API 2.0 integrates [SDKs](/api-reference/api-introduction/toolkit/api-sdk.md)，to make it easier for you to call APIs. More programming languages will be supported.

## 6. Error Codes

The following only lists the error codes related to the API business logic. For other error codes, see [Common Error Codes](/api-reference/api-introduction/instruction/commonerrorcode.md).

| HTTP Status Code | Error Code | Description |
| ---------------- | ---------- | ----------- |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.console.zenlayer.com/api-reference/compute/vm/disk/attachdisks.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
